diff --git a/docs/mintty.1 b/docs/mintty.1
index 3d616515..ba9186e9 100644
--- a/docs/mintty.1
+++ b/docs/mintty.1
@@ -248,6 +248,8 @@ as determined by mintty, and exits.
 With value "W", mintty lists installed WSL distributions and properties, 
 and exits.
 
+With value "p", mintty reports the PID of the child process (e.g. the shell).
+
 .TP
 \fB--store-taskbar-properties\fP
 Enable persistent storage of Windows taskbar properties together with 
diff --git a/src/child.c b/src/child.c
index 31a8ca12..1215a07d 100644
--- a/src/child.c
+++ b/src/child.c
@@ -330,6 +330,9 @@ child_create(char *argv[], struct winsize *winp)
     exit(mexit);
   }
   else { // Parent process.
+    if (report_child_pid)
+      printf("%d\n", pid);
+
 #ifdef __midipix__
     // This corrupts CR in cygwin
     struct termios attr;
diff --git a/src/winmain.c b/src/winmain.c
index 061d5440..5ece0841 100644
--- a/src/winmain.c
+++ b/src/winmain.c
@@ -102,6 +102,7 @@ bool title_settable = true;
 static string border_style = 0;
 static string report_geom = 0;
 static bool report_moni = false;
+bool report_child_pid = false;
 static int monitor = 0;
 static bool center = false;
 static bool right = false;
@@ -3431,7 +3432,8 @@ getlxssinfo(bool list, wstring wslname, uint * wsl_ver,
       printf("-- guid %ls\n", guid);
       printf("-- flag %u\n", getregval(lxss, guid, W("Flags")));
       printf("-- root %ls\n", rootfs);
-      printf("-- pack %ls\n", pn);
+      if (pn)
+        printf("-- pack %ls\n", pn);
       if (pfn)
         printf("-- full %ls\n", pfn);
       printf("-- icon %ls\n", icon);
@@ -4212,6 +4214,10 @@ main(int argc, char *argv[])
             exit(0);
           }
 #endif
+          when 'p':
+            report_child_pid = true;
+          otherwise:
+            option_error(__("Unknown option '%s'"), optarg, 0);
         }
       when 'u': cfg.create_utmp = true;
       when '':
diff --git a/src/winpriv.h b/src/winpriv.h
index a6fe658e..a203298f 100644
--- a/src/winpriv.h
+++ b/src/winpriv.h
@@ -37,6 +37,7 @@ extern char * fontpropinfo(void);
 extern bool title_settable;
 extern bool support_wsl;
 extern wstring wsl_basepath;
+extern bool report_child_pid;
 
 extern int ini_width, ini_height;
 extern bool win_is_fullscreen;
